Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at	(revision cc5db582dad56745fce8f970d96f7197f1842609)
+++ 	(revision )
@@ -1,35 +1,0 @@
-### fragment the molecule and check the number of configs
-
-AT_SETUP([Fragmentation - Automation: Adding jobs])
-AT_KEYWORDS([fragmentation automation server worker jobadder])
-
-# check that ports are unique over all tests such that they may run in parallel
-WORKERPORT=1035
-CONTROLLERPORT=1036
-WORKERLISTENPORT=1037
-
-# start service in background
-${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
-server_pid=$!
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-
-# add one jobs via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
-
-# enlist a worker to work on jobs
-${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
-worker_pid=$!
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# send kill signal to worker such that it shuts down
-AT_CHECK([kill -INT $worker_pid], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-
-# shutdown
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid] $worker_pid)
-
-# check that server is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([kill $server_pid $worker_pid], 1, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-checkstate.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-checkstate.at	(revision cc5db582dad56745fce8f970d96f7197f1842609)
+++ 	(revision )
@@ -1,26 +1,0 @@
-### fragment the molecule and check the number of configs
-
-AT_SETUP([Fragmentation - Automation: Checking results])
-AT_KEYWORDS([fragmentation automation server resultchecker])
-
-# check that ports are unique over all tests such that they may run in parallel
-WORKERPORT=1040
-CONTROLLERPORT=1041
-
-# start service in background
-${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
-server_pid=$!
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-
-# check jobs
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "0 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid])
-
-# shutdown
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid])
-
-# check that server is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([kill $server_pid], 1, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at	(revision cc5db582dad56745fce8f970d96f7197f1842609)
+++ 	(revision )
@@ -1,57 +1,0 @@
-### fragment the molecule and check the number of configs
-
-AT_SETUP([Fragmentation - Automation: Complete run])
-AT_KEYWORDS([fragmentation automation jobadder resultgetter resultchecker server shutdowner worker])
-
-# check that ports are unique over all tests such that they may run in parallel
-WORKERPORT=1050
-CONTROLLERPORT=1051
-WORKERLISTENPORT=1052
-
-# start service in background
-${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
-server_pid=$!
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-
-# add two jobs via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
-
-# Checking results
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "#3 are waiting in the queue and #0 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid])
-
-# enlist a worker to work on jobs
-${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
-worker_pid=$!
-AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# send kill signal to worker such that it shuts down
-AT_CHECK([kill -INT $worker_pid], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-
-# Checking results
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([fgrep "#0 are waiting in the queue and #3 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# get results
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([fgrep "Received 3 results" stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([fgrep -c "Nothing" stdout], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([grep "3" stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# get no more results
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([grep "Nothing" stdout], 1, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# shutdown
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-
-# check that server is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([kill $server_pid $worker_pid], 1, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-enrollinpool.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-enrollinpool.at	(revision cc5db582dad56745fce8f970d96f7197f1842609)
+++ 	(revision )
@@ -1,38 +1,0 @@
-### fragment the molecule and check the number of configs
-
-AT_SETUP([Fragmentation - Automation: Worker enrolls in pool])
-AT_KEYWORDS([fragmentation automation controller poolworker server shutdown])
-
-WORKERPORT=1055
-CONTROLLERPORT=1056
-WORKERLISTENPORT=1057
-
-# start service in background
-${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
-server_pid=$!
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-
-# check help of poolworker
-AT_CHECK([${AUTOTEST_PATH}/PoolWorker -h], 1, [ignore], [ignore], [kill $server_pid])
-
-# let worker enroll in pool
-${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
-worker_pid=$!
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# add one jobs via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# send kill signal to worker such that it shuts down properly
-AT_CHECK([kill -2 $worker_pid], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-
-# shutdown server as well
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# check that Server is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([kill $server_pid $worker_pid], 1, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-getresults.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-getresults.at	(revision cc5db582dad56745fce8f970d96f7197f1842609)
+++ 	(revision )
@@ -1,26 +1,0 @@
-### fragment the molecule and check the number of configs
-
-AT_SETUP([Fragmentation - Automation: Getting results])
-AT_KEYWORDS([fragmentation automation server resultgetter])
-
-# check that ports are unique over all tests such that they may run in parallel
-WORKERPORT=1045
-CONTROLLERPORT=1046
-
-# start service in background
-${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
-server_pid=$!
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-
-# directly obtain 0 results
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "RESULT" stdout], 1, [stdout], [ignore], [kill $server_pid])
-
-# shutdown
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid])
-
-# check that server is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([kill $server_pid], 1, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-resubmitjobs.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-resubmitjobs.at	(revision cc5db582dad56745fce8f970d96f7197f1842609)
+++ 	(revision )
@@ -1,41 +1,0 @@
-### fragment the molecule and check the number of configs
-
-AT_SETUP([Fragmentation - Automation: Resubmitting failed jobs])
-AT_KEYWORDS([fragmentation automation server worker jobadder])
-
-# check that ports are unique over all tests such that they may run in parallel
-WORKERPORT=1070
-CONTROLLERPORT=1071
-WORKERLISTENPORT=1072
-
-# start service in background
-${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
-server_pid=$!
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-
-# add one always failing job via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "/bin/false" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
-
-# enlist a worker to work on jobs
-${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT 2>workererr &
-worker_pid=$!
-AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# send kill signal to worker such that it shuts down
-AT_CHECK([kill -INT $worker_pid], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# check that it truely failed for four times
-AT_CHECK([fgrep -c "Job 1 failed on executing" workererr], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([grep "4" stdout], 0, [ignore], [ignore])
-
-# shutdown
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid])
-
-# check that server is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([kill $server_pid], 1, [ignore], [ignore])
-
-AT_CHECK([rm -f workererr], 0, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-shutdown.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-shutdown.at	(revision cc5db582dad56745fce8f970d96f7197f1842609)
+++ 	(revision )
@@ -1,23 +1,0 @@
-### fragment the molecule and check the number of configs
-
-AT_SETUP([Fragmentation - Automation: Server shutdown])
-AT_KEYWORDS([fragmentation automation server shutdowner])
-
-# check that ports are unique over all tests such that they may run in parallel
-WORKERPORT=1030
-CONTROLLERPORT=1031
-
-# start service in background
-${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
-server_pid=$!
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-
-# shutdown server again
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([grep "Operation completed." stdout], 0, [stdout], [ignore], [kill $server_pid])
-
-# server shuts down as queue is empty
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([kill $server_pid], 1, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at	(revision cc5db582dad56745fce8f970d96f7197f1842609)
+++ 	(revision )
@@ -1,38 +1,0 @@
-### fragment the molecule and check the number of configs
-
-AT_SETUP([Fragmentation - Automation: Server/Worker])
-AT_KEYWORDS([fragmentation automation server worker])
-
-# check that ports are unique over all tests such that they may run in parallel
-WORKERPORT=1025
-CONTROLLERPORT=1026
-WORKERLISTENPORT=1027
-
-# start service in background
-${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
-server_pid=$!
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-
-# add one jobs 
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [ignore], [ignore], [kill $server_pid])
-
-# enlist a worker to work on jobs
-${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
-worker_pid=$!
-AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# send kill signal to worker such that it shuts down
-AT_CHECK([kill -INT $worker_pid], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-
-# check number of done jobs
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "#0 are waiting in the queue and #1 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid])
-
-# shutdown controller socket 
-AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
-
-# check that server is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([kill $server_pid], 1, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Fragmentation/testsuite-fragmentation.at
===================================================================
--- tests/regression/Fragmentation/testsuite-fragmentation.at	(revision cc5db582dad56745fce8f970d96f7197f1842609)
+++ tests/regression/Fragmentation/testsuite-fragmentation.at	(revision 103eb8b758b1d67aaeaf2e52f87bfbba00a58174)
@@ -1,33 +1,9 @@
-AT_BANNER([MoleCuilder - Fragmentation and Re-fragmentation test])
+AT_BANNER([MoleCuilder - fragmentation tests])
 
-# fragment the molecule and check the number of configs
+# check fragmentation
 m4_include([Fragmentation/FragmentMolecule/testsuite-fragmentation-fragment-molecule.at])
 
 # check whether parsing of BondFragment files and re-rwriting config files is working (exit code is 2 as we don't need to continue wrt to ...OrderAtSite)
 m4_include([Fragmentation/FragmentMolecule-MaxOrder/testsuite-fragmentation-fragment-molecule-maxorder.at])
-
-# check whether server shutdown works
-m4_include([Fragmentation/Automation/testsuite-fragmentation-automation-server-shutdown.at])
-
-# check whether poolworker may succesfully enroll in pool
-m4_include([Fragmentation/Automation/testsuite-fragmentation-automation-enrollinpool.at])
-
-# check whether adding jobs works
-m4_include([Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at])
-
-# check whether checking state works
-m4_include([Fragmentation/Automation/testsuite-fragmentation-automation-checkstate.at])
-
-# check whether getting results works
-m4_include([Fragmentation/Automation/testsuite-fragmentation-automation-getresults.at])
-
-# check whether Server/Client construct for automatized calculation is working
-m4_include([Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at])
-
-# check whether complete run works
-m4_include([Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at])
-
-# check whether resubmitting of failed jobs works
-m4_include([Fragmentation/Automation/testsuite-fragmentation-automation-resubmitjobs.at])
 
 # check whether stand-in mpqc program works