Index: src/Actions/MoleculeAction/BondFileAction.cpp
===================================================================
--- src/Actions/MoleculeAction/BondFileAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/BondFileAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/BondFileAction.hpp"
Index: src/Actions/MoleculeAction/ChangeNameAction.cpp
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: crueger
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/ChangeNameAction.hpp"
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/FillWithMoleculeAction.hpp"
Index: src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp
===================================================================
--- src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp"
Index: src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp
===================================================================
--- src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp"
Index: src/Actions/MoleculeAction/SaveAdjacencyAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveAdjacencyAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/SaveAdjacencyAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/SaveAdjacencyAction.hpp"
Index: src/Actions/MoleculeAction/SaveBondsAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveBondsAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/SaveBondsAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/SaveBondsAction.hpp"
Index: src/Actions/MoleculeAction/SaveTemperatureAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveTemperatureAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/SaveTemperatureAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/SaveTemperatureAction.hpp"
Index: src/Actions/MoleculeAction/SuspendInWaterAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/SuspendInWaterAction.hpp"
Index: src/Actions/MoleculeAction/TranslateAction.cpp
===================================================================
--- src/Actions/MoleculeAction/TranslateAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/TranslateAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/TranslateAction.hpp"
Index: src/Actions/MoleculeAction/VerletIntegrationAction.cpp
===================================================================
--- src/Actions/MoleculeAction/VerletIntegrationAction.cpp	(revision 97ebf8b2670d891c06f34ede7594c6708e07d886)
+++ src/Actions/MoleculeAction/VerletIntegrationAction.cpp	(revision 112b090c14e4507fb9dde0a3a340b9a3d61823ba)
@@ -5,4 +5,6 @@
  *      Author: heber
  */
+
+#include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/VerletIntegrationAction.hpp"